using System;
using Microsoft.SPOT;
using System.Diagnostics;

// Display Modules...
using Gadgeteer.Modules.GHIElectronics;

namespace Cerberus_PWM
{
    public static class Display
    {
        public static void Write(Display_HD44780 char_Display, string LineOne, string LineTwo, bool Backlight)
        {
            // Clear the Display...
            char_Display.Clear();

            if (Backlight)
            {
                char_Display.SetBacklight(true);
            }
            else
            {
                char_Display.SetBacklight(false);
            }

            //////////////////////////////////////////////////////////////////////////////////
            // https://www.ghielectronics.com/docs/171/character-display-module             //
            // char_Display.Putc((byte)'H');                                                //
            //////////////////////////////////////////////////////////////////////////////////

            // Display the Text...
            char_Display.PrintString(LineOne);

            // Move to the next Line, position Zero...
            char_Display.SetCursor(1, 0);

            // Display the Text...
            char_Display.PrintString(LineTwo);
        }
    }
}
