using System;
using Microsoft.SPOT;

namespace Cerberus_PWM
{
    public static class GlobalVariable
    {
        #region Private variables...

        private static uint Freq_CH_1 = 3;
        private static uint Freq_CH_2 = 3;
        private static uint Freq_CH_3 = 3;
        private static uint Freq_CH_4 = 3;

        private static double Duty_Ch_1 = 0.5;
        private static double Duty_Ch_2 = 0.5;
        private static double Duty_Ch_3 = 0.5;
        private static double Duty_Ch_4 = 0.5;

        private static bool Ch_1_Invert = true;
        private static bool Ch_2_Invert = true;
        private static bool Ch_3_Invert = true;
        private static bool Ch_4_Invert = true;

        private static uint UpperFreqLimit = 1000000;
        private static uint LowerFreqLimit = 1;

        private static bool Sweep = false;
        private static int SweepSleepTime = 100;

        private static bool Blinking = false;
        private static int OnBoardLEDBlinkSleep = 200;

        #endregion

        /// <summary>
        /// PWM Channel 1 Frequency...
        /// </summary>
        public static uint CH_1_Frequency
        {
            get { return Freq_CH_1; }
            set { Freq_CH_1 = value; }
        }

        /// <summary>
        /// PWM Channel 2 Frequency...
        /// </summary>
        public static uint CH_2_Frequency
        {
            get { return Freq_CH_2; }
            set { Freq_CH_2 = value; }
        }

        /// <summary>
        /// PWM Channel 3 Frequency...
        /// </summary>
        public static uint CH_3_Frequency
        {
            get { return Freq_CH_3; }
            set { Freq_CH_3 = value; }
        }

        /// <summary>
        /// PWM Channel 4 Frequency...
        /// </summary>
        public static uint CH_4_Frequency
        {
            get { return Freq_CH_4; }
            set { Freq_CH_4 = value; }
        }

        /// <summary>
        ///  PWM Channel 1 Duty Cycle...
        /// </summary>
        public static double Ch_1_Duty
        {
            get { return Duty_Ch_1; }
            set { Duty_Ch_1 = value; }
        }

        /// <summary>
        ///  PWM Channel 1 Duty Cycle...
        /// </summary>
        public static double Ch_2_Duty
        {
            get { return Duty_Ch_2; }
            set { Duty_Ch_2 = value; }
        }

        /// <summary>
        ///  PWM Channel 1 Duty Cycle...
        /// </summary>
        public static double Ch_3_Duty
        {
            get { return Duty_Ch_3; }
            set { Duty_Ch_3 = value; }
        }

        /// <summary>
        ///  PWM Channel 1 Duty Cycle...
        /// </summary>
        public static double Ch_4_Duty
        {
            get { return Duty_Ch_4; }
            set { Duty_Ch_4 = value; }
        }

        /// <summary>
        /// Invert Pin on Channel 1.
        /// </summary>
        public static bool InvertChannel_1
        {
            get { return Ch_1_Invert; }
            set { Ch_1_Invert = value; }
        }

        /// <summary>
        /// Invert Pin on Channel 2.
        /// </summary>
        public static bool InvertChannel_2
        {
            get { return Ch_2_Invert; }
            set { Ch_2_Invert = value; }
        }

        /// <summary>
        /// Invert Pin on Channel3.
        /// </summary>
        public static bool InvertChannel_3
        {
            get { return Ch_3_Invert; }
            set { Ch_3_Invert = value; }
        }

        /// <summary>
        /// Invert Pin on Channel 4.
        /// </summary>
        public static bool InvertChannel_4
        {
            get { return Ch_4_Invert; }
            set { Ch_4_Invert = value; }
        }

        /// <summary>
        /// Upper Frequency Limit...
        /// </summary>
        public static uint UpperFrequencyLimit
        {
            get { return UpperFreqLimit; }
            set { UpperFreqLimit = value; }
        }

        /// <summary>
        /// Lower Frequency Limit...
        /// </summary>
        public static uint LowerFrequencyLimit
        {
            get { return LowerFreqLimit; }
            set { LowerFreqLimit = value; }
        }

        /// <summary>
        /// Boolean for Sweeping...
        /// </summary>
        public static bool IsSweeping
        {
            get { return Sweep; }
            set { Sweep = value; }
        }

        /// <summary>
        /// Sleep Time on Sweep in milliseconds...
        /// </summary>
        public static int SweepSleep
        {
            get { return SweepSleepTime; }
            set { SweepSleepTime = value; }
        }

        /// <summary>
        /// Boolean for Onboard LED Blinking...
        /// </summary>
        public static bool IsBlinking
        {
            get { return Blinking; }
            set { Blinking = value; }
        }

        /// <summary>
        /// Onboard LED Blink Sleep time in milliseconds...
        /// </summary>
        public static int LEDBlinkSleep
        {
            get { return OnBoardLEDBlinkSleep; }
            set { OnBoardLEDBlinkSleep = value; }
        }


    } // END of Class...
} // END of Namespace...