using System;
using System.Threading;
using Microsoft.SPOT;

namespace Cerberus_PWM
{
    /////////////////////////////////////////////////////////////////////////////
    // BASIC Software PLL - Implimented as a Current Sensing PLL...            //
    // By Chris Sykes...                                                       //
    /////////////////////////////////////////////////////////////////////////////

    public class PLL
    {
        // Constructor...
        public PLL()
        {
        }

        public void Start()
        {
            // Listen for the Current Sensor on another Thread...
            Thread CurrentMonitorThread = new Thread(CurrentPhaseLockedLoop);
            CurrentMonitorThread.Start();
        }

        private void CurrentPhaseLockedLoop()
        {
            bool Decrement = false;

            while (true)
            {
                if (Decrement)
                {
                    GlobalVariable.CH_1_Frequency = GlobalVariable.CH_1_Frequency - 1; // GetFrequencyPercentage(CH_1_Frequency);
                    GlobalVariable.CH_2_Frequency = GlobalVariable.CH_2_Frequency - 1; // GetFrequencyPercentage(CH_2_Frequency);

                    //PWMChannel.Channel_1.Configure(GlobalVariable.CH_1_Frequency, GlobalVariable.Ch_1_Duty);
                    //PWMChannel.Channel_2.Configure(GlobalVariable.CH_2_Frequency, GlobalVariable.Ch_2_Duty);

                    Thread.Sleep(GlobalVariable.SweepSleep);

                    if (GlobalVariable.CH_1_Frequency <= GlobalVariable.LowerFrequencyLimit)
                    {
                        Decrement = false;
                    }
                }
                else
                {
                    GlobalVariable.CH_1_Frequency = GlobalVariable.CH_1_Frequency + 1; // GetFrequencyPercentage(CH_1_Frequency);
                    GlobalVariable.CH_2_Frequency = GlobalVariable.CH_2_Frequency + 1; // GetFrequencyPercentage(CH_2_Frequency);

                    //PWMChannel.Channel_1.Configure(GlobalVariable.CH_1_Frequency, GlobalVariable.Ch_1_Duty);
                    //PWMChannel.Channel_2.Configure(GlobalVariable.CH_2_Frequency, GlobalVariable.Ch_2_Duty);


                    Thread.Sleep(GlobalVariable.SweepSleep);

                    if (GlobalVariable.CH_1_Frequency >= GlobalVariable.UpperFrequencyLimit)
                    {
                        Decrement = true;
                    }
                }
            }
        }


    } // END of Class...
} // END of Namespace...
