using System;
using Microsoft.SPOT;

namespace Cerberus_PWM
{
    /*
    class PWM_C___Class
    {

     * private static int[] STM32F4_PWM_TIMER = new int[] 
     * private static int[] STM32F4_PWM_CHNL = new int[] 
     * private static int[] STM32F4_PWM_PINS = new int[]  
                C6,    A7,     C7,    A8,     B0,     B1,     B5,     B4,     B3,   B11,    B10,    A10,    A9,     A15,      B8,     B9
        TIMER  { 8,    14,      8,     1,      3,      3,      3,      3,      2,   2,        2,      1,    1,      2,        4,       4 };
        CHNL   { 0,     0,      1,     0,      2,      3,      1,      0,      1,   3,        2,      2,    1,      0,        2,       3 };
        PINS   { 38,    7,     39,     8,      16,     17,     21,    20,     19,   27,      26,     10,    9,      15,      24,      25 };


        //Timers
        private static const int[] g_STM32F4_PWM_Timer = STM32F4_PWM_TIMER;
        private static const int[] g_STM32F4_PWM_Channel = STM32F4_PWM_CHNL;

        // Pins
        private static const int[] g_STM32F4_PWM_Pins = STM32F4_PWM_PINS;
        private int STM32F4_PWM_CHANNELS = g_STM32F4_PWM_Pins.Length; // number of channels


        // IO addresses
        private static unsafe STM32F4xx.TIM_TypeDef*[] g_STM32F4_PWM_Ports = { STM32F4xx.TIM1, STM32F4xx.TIM2, STM32F4xx.TIM3, STM32F4xx.TIM4, STM32F4xx.TIM5, null, null, STM32F4xx.TIM8, STM32F4xx.TIM9, TIM10, TIM11, TIM12, TIM13, TIM14 };


        // Alternate Function Number
        private static const byte[] g_STM32F4_PWM_Alt = { 0x12, 0x12, 0x22, 0x22, 0x22, 0, 0, 0x32, 0x32, 0x32, 0x32, 0x92, 0x92, 0x92 }; // AF1/2/3/9


        private static unsafe STM32F4xx.TIM_TypeDef* ptr_TIM_TypeDef;

        public static struct RCC_TypeDef //[2]
        {
            volatile uint CR;            //!< RCC clock control register,                                  Address offset: 0x00 
            volatile uint PLLCFGR;       //!< RCC PLL configuration register,                              Address offset: 0x04 
            volatile uint CFGR;          //!< RCC clock configuration register,                            Address offset: 0x08 
            volatile uint CIR;           //!< RCC clock interrupt register,                                Address offset: 0x0C 
            volatile uint AHB1RSTR;      //!< RCC AHB1 peripheral reset register,                          Address offset: 0x10 
            volatile uint AHB2RSTR;      //!< RCC AHB2 peripheral reset register,                          Address offset: 0x14 
            volatile uint AHB3RSTR;      //!< RCC AHB3 peripheral reset register,                          Address offset: 0x18 
            uint RESERVED0;     //!< Reserved, 0x1C                                                                    
            volatile uint APB1RSTR;      //!< RCC APB1 peripheral reset register,                          Address offset: 0x20 
            volatile uint APB2RSTR;      //!< RCC APB2 peripheral reset register,                          Address offset: 0x24 
            uint RESERVED1;  //!< Reserved, 0x28-0x2C                                                               
            volatile uint AHB1ENR;       //!< RCC AHB1 peripheral clock register,                          Address offset: 0x30 
            volatile uint AHB2ENR;       //!< RCC AHB2 peripheral clock register,                          Address offset: 0x34 
            volatile uint AHB3ENR;       //!< RCC AHB3 peripheral clock register,                          Address offset: 0x38 
            uint RESERVED2;     //!< Reserved, 0x3C                                                                    
            uint APB1ENR;       //!< RCC APB1 peripheral clock enable register,                   Address offset: 0x40 
            uint APB2ENR;       //!< RCC APB2 peripheral clock enable register,                   Address offset: 0x44 
            uint RESERVED3;  //!< Reserved, 0x48-0x4C                                                               
            volatile uint AHB1LPENR;     //!< RCC AHB1 peripheral clock enable in low power mode register, Address offset: 0x50 
            volatile uint AHB2LPENR;     //!< RCC AHB2 peripheral clock enable in low power mode register, Address offset: 0x54 
            volatile uint AHB3LPENR;     //!< RCC AHB3 peripheral clock enable in low power mode register, Address offset: 0x58 
            uint RESERVED4;     //!< Reserved, 0x5C                                                                    
            volatile uint APB1LPENR;     //!< RCC APB1 peripheral clock enable in low power mode register, Address offset: 0x60 
            volatile uint APB2LPENR;     //!< RCC APB2 peripheral clock enable in low power mode register, Address offset: 0x64 
            uint RESERVED5;  //!< Reserved, 0x68-0x6C                                                               
            volatile uint BDCR;          //!< RCC Backup domain control register,                          Address offset: 0x70 
            volatile uint CSR;           //!< RCC clock control & status register,                         Address offset: 0x74 
            uint RESERVED6;  //!< Reserved, 0x78-0x7C                                                               
            volatile uint SSCGR;         //!< RCC spread spectrum clock generation register,               Address offset: 0x80 
            volatile uint PLLI2SCFGR;    //!< RCC PLLI2S configuration register,                           Address offset: 0x84 
        }

        private static uint RCC_BASE = (AHB1PERIPH_BASE + 0x3800);
        private static unsafe RCC_TypeDef* RCC = ((RCC_TypeDef*)RCC_BASE);





        // Unsure....
        private static struct PWM_CHANNEL
        {
            uint CH = 0;
        }

        private static struct GPIO_PIN
        {
        }

        private static struct PWM_SCALE_FACTOR
        {
        }


        public static unsafe bool PWM_Initialize(PWM_CHANNEL channel)
        {
            if (channel >= STM32F4_PWM_CHANNELS) return false;
            int timer = g_STM32F4_PWM_Timer[channel];
            int tchnl = g_STM32F4_PWM_Channel[channel];
            TIM_TypeDef* treg = g_STM32F4_PWM_Ports[timer - 1];

            // relevant RCC register & bit
            uint enReg = &RCC->APB1ENR;
            if ((uint)treg == 0x10000) enReg = &RCC->APB2ENR;
            int enBit = 1 << (int)(((uint)treg >> 10) & 0x1F);


            if (!((int)enReg == enBit))
            { // not yet initialized
                enReg |= enBit; // enable timer clock
                treg->CR1 = TIM_CR1_URS | TIM_CR1_ARPE; // double buffered update
                treg->EGR = TIM_EGR_UG; // enforce first update
                if (timer == 1 || timer == 8)
                {
                    treg->BDTR |= TIM_BDTR_MOE; // main output enable (timer 1 & 8 only)    
                }
            }

            (uint)&((uint)&treg->CCR1)[tchnl] = 0; // reset compare register

            // enable PWM channel
            uint mode = TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1PE; // PWM1 mode, double buffered
            if (tchnl == 1) mode <<= 8; // 1 or 3
            uint reg = &treg->CCMR1;
            if (tchnl == 2) reg = &treg->CCMR2; // 2 or 3
            reg |= mode;

            return true;
        }

        private static unsafe bool PWM_Uninitialize(PWM_CHANNEL channel)
        {
            int timer = g_STM32F4_PWM_Timer[channel];
            int tchnl = g_STM32F4_PWM_Channel[channel];
            TIM_TypeDef* treg = g_STM32F4_PWM_Ports[timer - 1];

            uint mask = 0xFF; // disable PWM channel
            if (tchnl == 1) mask = 0xFF00; // 1 or 3
            uint reg = &treg->CCMR1;
            if (tchnl == 2) reg = &treg->CCMR2; // 2 or 3
            reg &= ~mask;

            if ((treg->CCMR1 | treg->CCMR2) == 0)
            { // no channel active
                uint enReg = &RCC->APB1ENR;
                if ((uint)treg == 0x10000) enReg = &RCC->APB2ENR;
                int enBit = 1 << (int)(((uint)treg >> 10) & 0x1F);
                enReg &= ~enBit; // disable timer clock
            }

            return true;
        }

        private static unsafe bool PWM_ApplyConfiguration(PWM_CHANNEL channel, GPIO_PIN pin, uint period, uint duration, PWM_SCALE_FACTOR scale, bool invert)
        {
            int timer = g_STM32F4_PWM_Timer[channel];
            int tchnl = g_STM32F4_PWM_Channel[channel];
            TIM_TypeDef* treg = g_STM32F4_PWM_Ports[timer - 1];

            uint p = period;
            uint d = duration;
            uint s = scale;

            if (d > p) d = p;

            // set pre, p, & d such that:
            // pre * p = PWM_CLK * period / scale
            // pre * d = PWM_CLK * duration / scale

            uint clk = PWM1_CLK_HZ;
            if ((uint)treg == 0x10000) clk = PWM2_CLK_HZ; // APB2

            uint pre = clk / s; // prescaler
            if (pre == 0)
            { // s > PWM_CLK
                uint sm = s / ONE_MHZ; // scale in MHz
                clk = PWM1_CLK_MHZ;      // clock in MHz
                if ((uint)treg == 0x10000) clk = PWM2_CLK_MHZ; // APB2
                if (p > 0xFFFFFFFF / PWM_MAX_CLK_MHZ)
                { // avoid overflow
                    pre = clk;
                    p /= sm;
                    d /= sm;
                }
                else
                {
                    pre = 1;
                    p = p * clk / sm;
                    d = d * clk / sm;
                }
            }
            else
            {
                while (pre > 0x10000)
                { // prescaler too large
                    if (p >= 0x80000000) return false;
                    pre >>= 1;
                    p <<= 1;
                    d <<= 1;
                }
            }
            if (timer != 2 && timer != 5)
            { // 16 bit timer
                while (p >= 0x10000)
                { // period too large
                    if (pre > 0x8000) return false;
                    pre <<= 1;
                    p >>= 1;
                    d >>= 1;
                }
            }
            treg->PSC = pre - 1;
            treg->ARR = p - 1;

            if (timer == 2)
            {
                if (tchnl == 0)
                    treg->CCR1 = d;
                else if (tchnl == 1)
                    treg->CCR2 = d;
                else if (tchnl == 2)
                    treg->CCR3 = d;
                else if (tchnl == 3)
                    treg->CCR4 = d;
            }
            else
                *(uint)&((uint)&treg->CCR1)[tchnl] = d;

            uint invBit = TIM_CCER_CC1P << (4 * tchnl);
            if (invert)
            {
                treg->CCER |= invBit;
            }
            else
            {
                treg->CCER &= ~invBit;
            }
            return true;
        }

        private static unsafe bool PWM_Start(PWM_CHANNEL channel, GPIO_PIN pin)
        {
            int timer = g_STM32F4_PWM_Timer[channel];
            int tchnl = g_STM32F4_PWM_Channel[channel];
            TIM_TypeDef* treg = g_STM32F4_PWM_Ports[timer - 1];

            CPU_GPIO_DisablePin(pin, RESISTOR_DISABLED, 1, (GPIO_ALT_MODE)g_STM32F4_PWM_Alt[timer - 1]);
            uint enBit = TIM_CCER_CC1E << (4 * tchnl);
            treg->CCER |= enBit; // enable output
            uint cr1 = treg->CR1;
            if ((cr1 & TIM_CR1_CEN) == 0)
            { // timer stopped
                treg->EGR = TIM_EGR_UG; // enforce register update
                treg->CR1 = cr1 | TIM_CR1_CEN; // start timer
            }
            return true;
        }

        void PWM_Stop(PWM_CHANNEL channel, GPIO_PIN pin)
        {
            int timer = g_STM32F4_PWM_Timer[channel];
            int tchnl = g_STM32F4_PWM_Channel[channel];
            TIM_TypeDef* treg = g_STM32F4_PWM_Ports[timer - 1];

            uint ccer = treg->CCER;
            ccer &= ~(TIM_CCER_CC1E << (4 * tchnl));
            treg->CCER = ccer; // disable output
            CPU_GPIO_DisablePin(pin, RESISTOR_DISABLED, 0, GPIO_ALT_PRIMARY);
            if ((ccer & (TIM_CCER_CC1E | TIM_CCER_CC2E | TIM_CCER_CC3E | TIM_CCER_CC4E)) == 0)
            { // idle
                treg->CR1 &= ~TIM_CR1_CEN; // stop timer
            }
        }

        private static unsafe bool PWM_Start(PWM_CHANNEL* channel, GPIO_PIN* pin, uint count)
        {
            for (int i = 0; i < count; i++)
            {
                if (!PWM_Start(channel[i], pin[i])) return false;
            }
            return true;
        }

        unsafe void PWM_Stop(PWM_CHANNEL* channel, GPIO_PIN* pin, uint count)
        {
            for (int i = 0; i < count; i++)
            {
                PWM_Stop(channel[i], pin[i]);
            }
        }

        private static uint PWM_PWMChannels()
        {
            return STM32F4_PWM_CHANNELS;
        }

        unsafe GPIO_PIN PWM_GetPinForChannel(PWM_CHANNEL channel)
        {
            if ((uint)channel >= STM32F4_PWM_CHANNELS) return GPIO_PIN_NONE;
            return g_STM32F4_PWM_Pins[channel];
        }


    }
     */
}
